Bug 765037 - (GLUSTER-3305) enable changing of volume type after its creation
enable changing of volume type after its creation
Status: CLOSED CURRENTRELEASE
Product: GlusterFS
Classification: Community
Component: glusterd (Show other bugs)
mainline
x86_64 Linux
medium Severity low
: ---
: ---
Assigned To: Amar Tumballi
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2011-08-02 03:26 EDT by Amar Tumballi
Modified: 2013-12-18 19:06 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Amar Tumballi 2011-08-02 03:26:42 EDT
ie, if volume is created with plain distribute, and user want to make it a 'replciate' type volume with 2 copies. 

Or if a volume has replica 2 as the setup, enable it to change to 'replica 3' during run time.

same with stripe.

also enable reducing the replica count.
Comment 1 Amar Tumballi 2011-09-05 23:01:09 EDT
Just for future reference:

Anand Avati: writing a generic balanced tree check is quite easy and elegant
  
you have to do two checks
  
1. depth of tree taking any path is the same
2. width of tree at any depth is the same
  
both these checks can be implemented without awareness of dht/afr/stripe so, build graph from existing volfile
  
prune out leaves based on the list of bricks to be removed normalize the graph (i.e, if a node has 0 subvolumes, take out that node - recursively upwards)
  
then check two constraints
  
1. graph is balanced
  
2. stripe degree has not decreased

this function will be so generic that tomorrow even if we re-architect volgen to cascade cluster xlators differently (says, stripe over afr over dht) even then it will work fine

3. if distributed degree is getting decreased, then unless it is a commit op, mark as decommissioned subvol
  
all these can be done very generically
Comment 2 Anand Avati 2011-10-28 05:42:11 EDT
CHANGE: http://review.gluster.com/158 (with this patch, one can do all the below operations:) merged in master by Vijay Bellur (vijay@gluster.com)
Comment 3 Amar Tumballi 2011-10-28 05:46:22 EDT
This feature is not going to be backported to release-3.2 version, and hence resolving this bug

Note You need to log in before you can comment on or make changes to this bug.